# Principles

## Zero configuration

Surfacing too much configuration to the users opens the door for creating strong dependencies with internal components of the CLI
and diverging from the standard setup, which in turn might complicate updating the CLI in the future.
This has traditionally been the case of many Javascript tools and frameworks,
and a huge source of frustation for developers.
We shouldn't make the same mistake and rather,
align with approaches like [NextJS](https://nextjs.org/)'s where a recently created project contains a `package.json` with **a single dependency**.


## Fixed dependencies

The widespread practice in the Javascript community regarding dependencies is having many tiny NPM packages over few yet more complete ones.
The consequence of that is very nested dependency graphs that often lead to incompabilities between nodes and with the system.
Developers resort to deleting `node_modules` with the aim that their dependency manager will resolve the incompatibilities.
If we had soft dependency requirements and allowed `peerDependencies` we'd make projects generated by the ClI more prone to these issues.
That's not what we want. Therefore, the CLI should have strict dependency requirements and avoid the usage of peer dependencies.
Moreover, the addition of `@shopify/cli` as a dependency will pull everything that's necessary for building for Shopify, and that includes runtime dependencies and tools.
